/$ CheckEvent.c

UpdateMaxHPTimer(){
  --MaxHPTimer;
  if (!MaxHPTimer){
    okmessage("Your head begins to","throb painfully.","","","");
    MaxHP=MaxHP-TempMaxHP;
  }
}

UpdateForget(){
  --ForgetTimer;
  if (!ForgetTimer)
  okmessage("Aha!","You found your map!","","","");
}

UpdateRegenTimer(){
  ++HP;
  if (HP>MaxHP) HP=MaxHP;
  --RegenTimer;
  if (!RegenTimer)
    okmessage("Your metabolism slows","back down to normal.","","","");
}
UpdatePoisonTimer(){
  --HP;
  if (HP<1){ Death="Potion of Poison";gameover();}
  --PoisonTimer;
  if (!PoisonTimer)
    okmessage("You finally start","to feel better.","","","");
}

UpdateSTATTimer(){
  --DEXTimer;
  --STRTimer;
  --CONTimer;
  if (!DEXTimer || !STRTimer || !CONTimer){
    okmessage("You feel as though","something has changed","","","");
    if (!DEXTimer) {Dex=Dex-TempDEX; TempDEX=0;}
    if (!CONTimer) {Con=Con-TempCON; TempCON=0;}
    if (!STRTimer) {Str=Str-TempSTR; TempSTR=0;}
  }
}

teleport(){
  int x,y;
  if (randmap){
  do{
  x=random(31);
  y=random(31);
  }while (pmap[x][y]==1);}
  else {
    do{
  x=random(30);
  y=random(30);
  }while (pmap[x][y]==1);}
  mx=x; my=y;
  dir=random(4);
}

ShowEvent(int E){
int action,Evt,switch;
action=0;  //E is the loop counter sent in
	       //Event holds the specific events generated for this level
	       //Evt is the current event selected to activate

Evt=Event[E];

  if (Evt==1){ // Fountain of Healing
    action=yesno("You have found a fountain.","Do you wish to","drink from it?");
    if (action){
      HP=MaxHP;
      Event[E]=0;
    }
    return;
  }
  if (Evt==2){ // Polluted Fountain
    action=yesno("You have found a fountain.","Do you wish to","drink from it?");
    if (action){
      HP=HP-(random(5)+1);
      if (HP<1){
        okmessage("Uh Oh.","That was terrible.","Your stomach cramps.","You are dead.","");
        Death="Polluted Fountain";
        cleartitle();}
      else okmessage("Yuck!","That was nasty!","","","");
      Event[E]=0;
    }
    return;
  }
  if (Evt==3){ // Teleport
    teleport();
    action=random(3);
    if (!action)
      Event[E]=0;
    return;
  }
  if (Evt==4){ // Curse of Forgetfulness
    ForgetTimer=random(100)+100;
    okmessage("*POOF!* A red fog","bursts from the floor!","Your head begins to","throb.","");
    Event[E]=0;
    return;
  }
  if (Evt==5 || Evt==6 || Evt==7){ // Stat modifiers.
    action=random(3);
    if (action==0){
      if (!TempSTR){
      TempSTR=random(2)+1;
      switch=random(2);
      if (switch) TempSTR=TempSTR*(-1);
      Str=Str+TempSTR;
      STRTimer=random(100)+50;
      }
    }
    if (action==1){
      if (!TempCON){
      TempCON=random(2)+1;
      switch=random(2);
      if (switch) TempCON=TempCON*(-1);
      Con=Con+TempCON;
      CONTimer=random(100)+50;
      }
    }
    if (action==2){
      if (!TempDEX){
      TempDEX=random(2)+1;
      switch=random(2);
      if (switch) TempDEX=TempDEX*(-1);
      Dex=Dex+TempDEX;
      DEXTimer=random(100)+50;
      }
    }
  okmessage("*Click*","You have stepped on","a pressure plate.","Magical energies flow","through you.");
  Event[E]=0;
  return;
  }
  if (Evt==8){ // A pit!  Drop one level.
    okmessage("A trapdoor opens beneath","you!","*WHUMP!*","Ouch that hurts!","");
    ++Lev;
    HP=HP-random(5)+5;
    if (HP<1) HP=1;
    dinit(0,1);
  }
  if (Evt==9 || Evt==10) {
    action=random(2);
      if (!MaxHPTimer){
        MaxHPTimer=random(100)*Level+50;
        TempMaxHP=TempMaxHP+random(20)+10;
        if ((MaxHP-8)<TempMaxHP) TempMaxHP=MaxHP-8;
        if (action) TempMaxHP=TempMaxHP*(-1);
        MaxHP=MaxHP+TempMaxHP;
      }
    okmessage("*CLICK*","A blue dust blows into","your face!","You start to feel dizzy.","");
    Event[E]=0;
  }     
}

ExitLevel(){
int i;
i=0;

 i=yesno("You have found the","exit to this level!","Go down a level now?");
 if (i){
   ++Lev;
   dinit(0,1);
 }  
 
}
CheckEvent(){
int EventX[9]={11,23,9,16,28,2,23,14,7};
int EventY[9]={1,6,7,13,17,18,21,25,28};
int loop;

  // Check for Level Exit
  if (mx==DExitX)
   if (my==DExitY){
    ExitLevel();
    return;}
  loop=9;
  while(loop--){
  //for (loop=0;loop<9;++loop){
    if (mx==EventX[loop])
     if (my==EventY[loop]){
      ShowEvent(loop);
      break;
     }
  }
}
 