/$ mazegen.c
/*
 * maz.c - generate a maze
 *
 * algorithm posted to rec.games.programmer by jallen@ic.sunysb.edu
 * program cleaned and reorganized by mzraly@ldbvax.dnet.lotus.com
 *
 * don't make people pay for this, or I'll jump up and down and
 * yell and scream and embarass you in front of your friends...
 *
 * PocketC version with some changes that probably slow it down immensely.  Heh.
 * Change x and y in the main function to get different sizes.  The output chars
 * are customizable as well, they default to palm characters of the same width.  :)
 * modified by Vilmos - vilmos_@hotmail.com, with appologies to the original author
 * for the mess.
 */
mazegen(int pos,pointer maz,int y, int x, int rnd);

/*
 * maze() : generate a random maze of size (y by x) in maz, using vc as the
 * vertical character, hc as the horizontal character, and fc as the floor
 * character
 *
 * maz is an array that should already have its memory allocated - you could
 * malloc a char string if you like.
 */

int maze(pointer maz,int y, int x)

{
   int             i, yy, xx;
   int             max;
   int             rnd;
   /* For now, return error on even parameters */
   /* Alternative is to decrement evens by one */
   /* But really that should be handled by caller */
   max=y*x;
   rnd=random(43263634567);
   if (!(y & 1) | !(x & 1))
      return (1);

   /* I never assume... */
   i=max;
   while(i--){
      maz[i] = 1;
   }
    mazegen((x + 1),maz,y,x,rnd);
    return 0;

}

int calcd1(int pos,pointer maz,int x){
   if (pos <= x * 2)
   return 0;
   else
   if (!maz[pos - x - x])
   return 0;
   else
   return 1;
   }
int calcd2(int pos,pointer maz,int x, int y){
   if (pos>=x*(y-2))
     return 0;
   else
   if (!maz[pos+x+x])
     return 0;
   else return 2;
   }
int calcd3(int pos,pointer maz,int x){
   if (pos%x==x-2)
     return 0;
   else
    if (!maz[pos+2])
     return 0;
    else return 4;
   }
int calcd4(int pos,pointer maz,int x){
   if (pos%x==1)
     return 0;
   else
    if (!maz[pos-2])
     return 0;
    else return 8;
}
/*
 * mazegen : do the recursive maze generation
 *
 */

mazegen(int pos,pointer maz,int y, int x, int rnd)
{
   int             d, i, j;

   maz[pos] = 0;

   while (d=(calcd1(pos,maz,x)|calcd2(pos,maz,x,y)|calcd3(pos,maz,x)|calcd4(pos,maz,x))){   

      do {
         rnd = (rnd*57+1);
         i = 3 & (rnd / d);
    
      } while (!(d & (1 << i)));

	  if (!i)
	    j=-x;
	  if (i==1)
	    j=x;
	  if (i==2)
	    j=1;
	  if (i==3)
	    j=-1;
	  maz[pos + j] = 0;
      mazegen((pos + 2 * j),maz,y,x,rnd);
   }
   return;
}
mazemain()
{
   int  i,x,y,j;
 
   pointer maz;

 x = 31;
 y = 31;
 maz=map;

/*   for (i=0;i<31;i++)
     twod[i]=map + i*31;*/
 maze(maz,y,x);

/*   for (i=0;i<31;i++){
     for(j=0;j<31;j++){
     puts(twod[i][j]);}
     puts("\n");
   }*/
}

