/$ mazegen.c
/*
 * maz.c - generate a maze
 *
 * algorithm posted to rec.games.programmer by jallen@ic.sunysb.edu
 * program cleaned and reorganized by mzraly@ldbvax.dnet.lotus.com
 *
 * don't make people pay for this, or I'll jump up and down and
 * yell and scream and embarass you in front of your friends...
 *
 * PocketC version with some changes that probably slow it down immensely.  Heh.
 * Change x and y in the main function to get different sizes.  The output chars
 * are customizable as well, they default to palm characters of the same width.  :)
 * modified by Vilmos - vilmos_@hotmail.com, with appologies to the original author
 * for the mess.
 */
mazegen(int pos, int rnd);

int rnd;
pointer maz;


/*
 * maze() : generate a random maze of size (y by x) in maz, using vc as the
 * vertical character, hc as the horizontal character, and fc as the floor
 * character
 *
 * maz is an array that should already have its memory allocated - you could
 * malloc a char string if you like.
 */

int maze()

{
   int             i, yy, xx;
   int             max;
   int             rnd;
   int ii;
   /* For now, return error on even parameters */
   /* Alternative is to decrement evens by one */
   /* But really that should be handled by caller */
   max=31*31;
   rnd=random(432567857230398573902803957);
   if (!(31 & 1) | !(31 & 1))
      return (1);
   ii=ticks();

   /* I never assume... */
   i=max;
   while(i--){
     for (i = 0; i < max; ++i)
      maz[i] = 1;
   }
   ii=ticks()-ii;
      puts("1-Ticks: "+ii+"\n");
    mazegen(32,rnd);
    return 0;

}

int calcd1(int pos){
   if (pos <= 62)
   return 0;
   else
   if (!maz[pos - 62])
   return 0;
   else
   return 1;
   }
int calcd2(int pos){
   if (pos>=899)
     return 0;
   else
   if (!maz[pos+62])
     return 0;
   else return 2;
   }
int calcd3(int pos){
   if (pos%31==29)
     return 0;
   else
    if (!maz[pos+2])
     return 0;
    else return 4;
   }
int calcd4(int pos){
   if (pos%31==1)
     return 0;
   else
    if (!maz[pos-2])
     return 0;
    else return 8;
}
/*
 * mazegen : do the recursive maze generation
 *
 */

mazegen(int pos, int rnd)
{
   int             d, i, j;

   maz[pos] = 0;

   while (d=(calcd1(pos)|calcd2(pos)|calcd3(pos)|calcd4(pos))){   

      do {
         rnd = (rnd*57+1);
         i = 3 & (rnd / d);
    
      } while (!(d & (1 << i)));

	  if (!i)
	    j=-31;
	  if (i==1)
	    j=31;
	  if (i==2)
	    j=1;
	  if (i==3)
	    j=-1;
	  maz[pos + j] = 0;
      mazegen((pos + 2 * j),rnd);
   }
   return;
}
main()
{
   char TheMaze[961];
   int  i,tt;
clear();
 maz=TheMaze;
   tt=ticks();
   if (!maze()) {
      tt=ticks()-tt;

      for (i = 0; i < (31 * 31); ++i) {
         puts((int)maz[i]);
         if (((i + 1) % 31) == 0)
             puts('\n');
      }
   } else {
		puts("Couldn't make the maze\n");
   }
   puts("Ticks: "+tt);
}

